﻿© Fluke. All Rights Reserved.                               MET/CAL Procedure
=============================================================================
INSTRUMENT:            Sub TTi Function Generator Send Command, Wait for OPC
DATE:                  2010-07-23 12:07:03
AUTHOR:                Fluke Calibration
REVISION:              $Revision: 2619 $
ADJUSTMENT THRESHOLD:  70%
NUMBER OF TESTS:       1
NUMBER OF LINES:       112
=============================================================================
#
#  Procedure Author:
#        DAC
#
#  Models covered:
#        Fluke 281, 282, & 284
#        Fluke 291, 292, & 294
#        TTi TGA1241, TGA1242, & TGA1244
#        TTi TGA12101, TGA12102, & TGA12104
#        Wavetek 39A & 195
#
#  Compatibility:
#        MET/CAL 7.20 SP1 (7.20x) or later
#
#  Subprocedures:
#        None
#
#  Required Files:
#        None
#
#  Required Equipment:
#        None
#
#  The copyright in this procedure is owned by Fluke Corporation.
#
#
#  Example Usage:
#
 STEP    FSC    RANGE NOMINAL        TOLERANCE     MOD1        MOD2  3  4 CON

  1.001  MATH         TimeRemaining = @Timeout
#
# *SRE  0  Inhibit all SRQ's (This was added because Portocal II enabled
#          UUT SRQ's to enable communication using Wavetest.
#
#      32  Command Error
#      16  Execution Error
#       8  Device Dependent Error
#       4  Query Error
#       1  Operation Complete (OPC)
#      --
# *ESE 61  Set the Event Status Enable mask (ESE) so the Event Status Bit
#          (ESB) is set in the status byte for the listed conditions.
#
# @Cmd     Command to send
#
# *OPC     Set Operation Complete bit (OPC) in Event Status Register (ESR)
#          to 1 when all pending operations have completed.
#
  1.002  MATH         Error = 0; OPC = 0
  1.003  IEEE         *SRE 0;*ESE 61;[V @Cmd];*OPC

  1.004  DO

# Serial poll the instrument until the ESB is set in the status byte.
  1.005  DO
# ESB is bit 5, decimal 32.
  1.006  IEEE         [D100][SPL 32]
  1.007  MATH         TimeRemaining = TimeRemaining - 100
  1.008  MATH         TimedOut = (TimeRemaining <= 0)
  1.009  UNTIL        (MEM > 0) || TimedOut

  1.010  IF           TimedOut
  1.011  MATH         Error = 1
  1.012  MATH         ErrMsg = "Timeout waiting for Operation Complete (OPC)."
  1.013  ELSE
  1.014  IEEE         *ESR?[I]

# Note, the following conditions are ignored:
#   Bit 7: Power On
#   Bit 6: User Request
#   Bit 2: Query Error
#   Bit 1: Request Control

  1.015  IF           BIT(5, MEM)
  1.016  MATH         Error = 1; ErrMsg = "Command Error"
  1.017  ELSEIF       BIT(4, MEM)
  1.018  MATH         Error = 1; ErrMsg = "Execution Error"
  1.019  ELSEIF       BIT(3, MEM)
  1.020  MATH         Error = 1; ErrMsg = "Device Dependent Error"
  1.021  ELSEIF       BIT(0, MEM)
  1.022  MATH         OPC = 1
  1.023  ENDIF

  1.024  ENDIF        ; TimedOut

  1.025  UNTIL        OPC || Error

  1.026  IF           Error
  1.027  OPBR         -z [V ErrMsg]
  1.027  OPBR
  1.027  OPBR         Do you wish to continue?
  1.028  MATH         @Abort = MEM1
  1.029  ELSE
  1.030  MATH         @Abort = 0
  1.031  ENDIF

  1.032  END
